package fr.velossity.sample.device.impl;

import java.util.Dictionary;
import java.util.Hashtable;

import org.osgi.framework.BundleContext;

import fr.velossity.sample.device.Measurement;
import fr.velossity.sample.device.eventing.MeasurementHandler;

/**
 * 
 * @author C. Saint-Marcel
 * 
 */
public class Consumer implements MeasurementHandler {

	/**
	 * The producer identifier
	 */
	private String identifier;
	
	public Consumer(String identifier) {
		this.identifier = identifier;
	}
	
	
	/**
	 */
	public void activate(BundleContext context) throws Exception {
		// Service class name
		String clazz = MeasurementHandler.class.getName();

		// PUBLISHES the MeasurementListener service
		Dictionary props = new Hashtable();
		props.put("identifier", identifier);
		context.registerService(clazz, this, props);

	}

	/**
	 */
	public void deactivate(BundleContext context) throws Exception {
	}

	/**
	 * @see MeasurementHandler#newMeasure(Measurement)
	 */
	public void newMeasure(final Measurement measurement) {
		System.out.println("New measure [" + measurement.getSource().getIdentifier() + "]= " + measurement.getValue() + " " + measurement.getUnit());		
	}

}
